#include "ops/header.h"

/*************
 *
 *   random_permutation()
 *
 *************/

void random_permutation(int *a, int n)
{
  int i, t, k;
  for (i = 0; i < n; i++)
    a[i] = i;
  for (i = n-1; i >= 0; i--) {
    /* Get a random number k in [0,...,i], then swap a[i] and a[k]. */
    k = rand() % (i+1);
    t = a[i];
    a[i] = a[k];
    a[k] = t;
  }
}  /* random_permutation */

/*************
 *
 *   int_power()
 *
 *************/

int int_power(int n, int exp)
{
  if (exp <= 0)
    return 1;
  else
    return n * int_power(n, exp-1);
}  /* int_power */

