#ifndef TP_IOUTIL_H
#define TP_IOUTIL_H

#include "parse.h"
#include "formula.h"
#include "clist.h"
#include "just.h"
#include "clauseid.h"
#include "accanon.h"

/* INTRODUCTION
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from ioutil.c */

void fwrite_formula(FILE *fp, Formula f);

Clause read_clause(FILE *fin, FILE *fout);

Clist read_clause_list(FILE *fin, FILE *fout, char *name, BOOL assign_id);

void fwrite_clause(FILE *fp, Clause c, BOOL print_id);

void fwrite_clause_list(FILE *fp, Clist lst, BOOL print_ids);

Formula read_formula(FILE *fin, FILE *fout);

Glist read_formula_list(FILE *fin, FILE *fout);

void fwrite_formula_list(FILE *fp, Glist lst, char *name);

void zap_formula_list(Glist lst);

BOOL end_of_list_term(Term t);

Glist read_term_list(FILE *fin, FILE *fout);

void fwrite_term_list(FILE *fp, Glist lst, char *name);

void zap_term_list(Glist lst);

#endif  /* conditional compilation of whole file */
