#ifndef TP_PARAMOD_H
#define TP_PARAMOD_H

#include "clash.h"
#include "parautil.h"

/* INTRODUCTION
This package has a paramodulation inference rule.
*/

/* Public definitions */

/* where to paramodulate into */

typedef enum { PARA_ALL, PARA_ALL_EXCEPT_TOP, PARA_TOP_ONLY } Para_loc;

/* End of public definitions */

/* Public function prototypes from paramod.c */

Glist para_from_into(Clause from, Clause into, Para_loc where,
		    BOOL extend_from, BOOL extend_into);

#endif  /* conditional compilation of whole file */
